# Contributing to Gotham

Please take a moment to review this document in order to make the contribution
process easy and effective for everyone involved.

All aspects of the contribution process must adhere to 
[Gotham policies](https://github.com/gotham-rs/policies). 
Take a moment to read these now if you've not previously had a chance to
consider them.

## License

You agree to license your contribution under the 
[MIT License](LICENSE-MIT) **AND** the [Apache License 2.0](LICENSE-APACHE).

## Submission guidelines

Ensure your contribution has been run through 
[rustfmt](https://github.com/rust-lang-nursery/rustfmt) version 0.9 or later. 

You might also like to consider using 
[clippy](https://github.com/rust-lang-nursery/rust-clippy).

Document your contribution per the 
[Rust documentation guidelines](https://doc.rust-lang.org/book/first-edition/documentation.html).

Provide tests that prove the functionality you're contributing is correct.

Ensure your contribution is free of all warnings and errors during compilation 
and testing. Gotham deliberately targets higher levels of warnings than you may 
have seen previously in order to maintain quality.

## Pull requests

Pull requests that fix bugs, make improvements or add new features are very 
welcome, they are one of the main points of collaboration for the Gotham project. 

Pull requests should remain focused in scope and not contain unrelated commits.

**Please talk to us** before embarking on any significant pull request otherwise 
you risk spending a lot of time working on something that might not be a fit. 
IRC, email and issues are all good avenues to do this.

The Gotham project may use various bots and tools to automatically verify 
submitted pull requests. Ensure you address any errors these tools may report.

The Gotham core team may choose to **not** accept your contribution. 
When this happens we'll explain why and where possible make suggestions for how 
you might be able to achieve what you set out to with your pull request.
