# Gotham

A flexible web framework that does not sacrifice safety, security or speed.

The Gotham core team loves many of the elegant concepts that are found in dynamically typed web application frameworks, such as Rails, Phoenix and Django and aspire to achieve them with the type and memory safety guarantees provided by Rust.

Gotham is stability focused. All releases of Gotham are compatible with stable Rust and that contract will never change. To ensure we remain compatible, we also regularly build against beta and nightly Rust.

Gotham leverages async extensively thanks to the [Tokio project](https://tokio.rs) and is further enhanced by being built directly on top of async [Hyper](https://hyper.rs). Simple Gotham request handlers are able to complete in **µs** with very low memory requirements.

## License
Gotham is licensed under your option of:

* [MIT License](LICENSE-MIT)
* [Apache License, Version 2.0](LICENSE-APACHE)

## Learning Gotham
All of the following resources are available to assist you learning Gotham:

* [The Gotham website](https://gotham.rs)
* [Our API documentation](https://docs.rs/gotham/)
* [The Gotham book](https://book.gotham.rs)
* [Our example application](https://github.com/gotham-rs/example-app)

## Help
The Gotham core team collaborate on the [#gotham](https://chat.mibbit.com/?server=irc.mozilla.org&channel=%23gotham) channel on irc.mozilla.org. Gotham specific chat and requests for help are both very welcome here.

Additionally the Gotham core team often hang out in
[#rust-webdev](https://chat.mibbit.com/?server=irc.mozilla.org&channel=%23rust-webdev) and [#rust](https://chat.mibbit.com/?server=irc.mozilla.org&channel=%23rust).

## Policies
Gotham is a young project that we want to create an energetic and respectful community around.

As a starting point we've adopted the following [policies](https://github.com/gotham-rs/policies) which we'd like your help in refining further.

These policies are in effect for any environment or tool that supports the Gotham project.


## News
You can keep up with Gotham at:

* [Our blog](https://staging.gotham.rs/blog)
* [On Twitter](https://twitter.com/gotham_rs)
